<template>
  <button
    v-bind="$attrs"
    :disabled="disabled"
    :class="{
      'Button--iconLeft': iconLeft,
    }"
    :title="title || label"
    class="Button"
  >
    <span v-if="label" class="Button__Label">{{ label }}</span>
    <Icon v-if="icon" :icon="icon" class="Button__Icon" />
  </button>
</template>

<script lang="ts">
import { defineComponent } from 'vue'
import Icon from '@/components/Icon.vue'

export default defineComponent({
  components: { Icon },
  props: {
    label: String,
    title: String,
    icon: String,
    iconLeft: Boolean,
    disabled: {
      type: Boolean,
      default: false,
    },
  },
})
</script>

<style lang="scss" scoped>
@use '../style/variables' as v;
@use 'sass:math';

.Button {
  $root: &;

  display: inline-flex;
  align-items: center;
  justify-content: space-between;
  padding: v.$spacing-2;
  border-width: 1px;
  border-style: solid;
  border-radius: v.$borderRadius;
  background-color: var(--button-background-color);
  background-position: center;
  color: var(--button-text-color);
  cursor: pointer;
  transition: background 200ms;

  &__Label {
    display: inline-flex;
    order: 2;
    min-height: 1em;
    margin: 0 v.$spacing-2 0 0;
    line-height: 1em;
  }

  &__Icon {
    order: 3;
  }

  &--iconLeft {
    #{$root}__Icon {
      order: 1;
    }

    #{$root}__Label {
      margin: 0 0 0 v.$spacing-2;
    }
  }

  &:disabled {
    opacity: 50%;
    cursor: not-allowed;
  }

  &--outlined:not(:hover),
  &--outlined:disabled:hover,
  &:not(&--outlined):not(:disabled):hover {
    border-color: var(--button-background-color);
    background-color: transparent;
    color: var(--button-background-color);
  }

  &--noBorder {
    border-width: 0;
  }
}
</style>
